﻿Public Class cVaxStealthListen

    'Call is from a stealth-listener, who wants to listen the conversation of a User.

    Public Sub OnIncomingCall(ByVal nSessionId As Integer, ByVal sDialNo As String, ByVal nFromPeerType As Integer, ByRef bProcessed As Boolean)

        bProcessed = False

        If (Not IsCallFromStealthListener(sDialNo)) Then
            Return
        End If

        If (nFromPeerType <> cVaxServerCOM.VAX_PEER_TYPE_USER) Then
            Return
        End If

        Dim sPeerName As String = sDialNo
        sPeerName = sPeerName.Trim()
        sPeerName = sPeerName.Replace("#1#", "")

        cVaxServerExCOM.m_objServerExCOM.AcceptCallSession(nSessionId, "", "", "", -1, "")
        cVaxServerExCOM.m_objServerExCOM.AddStealthListener(nSessionId, cVaxServerCOM.VAX_PEER_TYPE_USER, sPeerName, cVaxServerCOM.TYPE_VOICE_ADMIN)

        bProcessed = True

    End Sub

    Private Function IsCallFromStealthListener(ByVal sDialNo As String) As Boolean

        If (sDialNo.IndexOf("#1#") <> 0) Then
            Return False
        End If

        Return True

    End Function

End Class
