﻿using System;
using System.Collections.Generic;
using System.Linq;
using System.Text;

namespace ServerSIP
{
    class cVaxRoom
    {
        string m_sRoomName = "";

        public cVaxRoom()
        {
        }

        ~cVaxRoom()
        {
        }

        ////////////////////////////////////////////////////////////////////////////
        ///////////////////////////////////////////////////////////////////////////

        public void OnIncomingCall(int nSessionId, string sRoomName, ref bool bProcessed)
        {
            bProcessed = false;

            if(sRoomName.Length == 0)
              return;
            
            m_sRoomName = sRoomName;

            if(!cVaxServerExCOM.m_objVaxServerExCOM.AcceptCallSession(nSessionId, "", "", "", -1, ""))   //AcceptCallSession(nSessionId, "", "", "", -1, "") // Accept the incoming call and add to conference room in OnCallSessionConnected()
            {
                cVaxServerExCOM.m_objVaxServerExCOM.RejectCallSession(nSessionId, 404, "Not Found");
                return;
            }

            bProcessed = true;

        }

        public void OnCallSessionConnected(int nSessionId)
        {
            if(m_sRoomName.Length == 0)
                return;

            cVaxServerExCOM.m_objVaxServerExCOM.AddCallSessionToConferenceRoom(m_sRoomName, nSessionId, cVaxServerCOM.TYPE_VOICE_NORMAL);
        }

        ////////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////  CVaxHold  ////////////////////////////////////////

        public void OnCallSessionOnHold(int nSessionId, int nChannelId)
        {
            if(m_sRoomName.Length == 0)
                return;
        }

        public void OnCallSessionOffHold(int nSessionId, int nChannelId)
        {
            if(m_sRoomName.Length == 0)
                return;
        }

        ////////////////////////////////////////////////////////////////////////////////////////////
        ////////////////////////////////////  CVaxTransfer  ////////////////////////////////////////

        public void OnCallSessionTransferBlind(int nTransfererSessionId, int nTransfererChannelId, string sTransferer, string sTransferee, string sTransferTo)
        {
            if(m_sRoomName.Length == 0)
                return;
            
            cVaxServerExCOM.m_objVaxServerExCOM.RejectTransfer(nTransfererSessionId);
        }

        public void OnCallSessionTransferConsult(int nTransfererSessionId, int nTransfererChannelId, int nTransferToSessionId, int nTransferToChannelId, string sTransferer, string sTransferee, string sTransferTo)
        {
            if(m_sRoomName.Length == 0)
                return;

            cVaxServerExCOM.m_objVaxServerExCOM.RejectTransfer(nTransfererSessionId);
        }
    }
}
