#include "stdafx.h"
#include "StealthListen.h"

#include"VaxServerExCOM.h"

CStealthListen::CStealthListen(void)
{
}


CStealthListen::~CStealthListen(void)
{
}

void CStealthListen::OnIncomingCall(LONG lSessionId, LPCTSTR sDialNo, LONG lFromPeerType, BOOL& bProcessed)
{
	bProcessed = FALSE;

	if(!IsStealthListenerCall(sDialNo))
		return;
	
	bProcessed = TRUE;

	if(lFromPeerType != VAX_PEER_TYPE_USER)
		return;

	CString sPeerName = sDialNo;
	sPeerName.Trim();
	sPeerName.Replace("#1#", "");

	CVaxServerExCOM::m_pVaxServerExCOM->AcceptCallSession(lSessionId, "", "", "", -1, "", 20);
	CVaxServerExCOM::m_pVaxServerExCOM->AddStealthListener(lSessionId, VAX_PEER_TYPE_USER, sPeerName, TYPE_VOICE_ADMIN);
}

BOOL CStealthListen::IsStealthListenerCall(LPCTSTR sDialNo)
{
	if(CString(sDialNo).Find("#1#") == 0)
		return TRUE;

	return FALSE;
}