#include "stdafx.h"
#include "VaxUserData.h"


CVaxUserData::CVaxUserData(void)
{
	m_bBlocked = FALSE;
	m_bRegistered = FALSE;
}

CVaxUserData::~CVaxUserData(void)
{
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

void CVaxUserData::SetData(LPCTSTR sPassword, LPCTSTR sCodecList, BOOL bBlocked, LPCTSTR sUserPrefix, LPCTSTR sDialPrefix, int nToPeerType, LPCTSTR sToPeerName,  BOOL bStealthlisten)
{
	m_sPassword   = sPassword;
	m_sCodecList  = sCodecList;

	m_bBlocked    = bBlocked;
	
	m_sUserPrefix = sUserPrefix;
	m_sDialPrefix = sDialPrefix;

	m_nToPeerType = nToPeerType;
	m_sToPeerName = sToPeerName;

	m_bStealthlisten = bStealthlisten;
}

void CVaxUserData::GetData(CString& sPassword, CString& sCodecList, BOOL& bBlocked, CString& sUserPrefix, CString& sDialPrefix, int& nToPeerType, CString& sToPeerName,  BOOL& bStealthlisten)
{
	sPassword   = m_sPassword;
	sCodecList  = m_sCodecList;

	bBlocked    = m_bBlocked;
	
	sUserPrefix = m_sUserPrefix;
	sDialPrefix = m_sDialPrefix;

	nToPeerType = m_nToPeerType;
	sToPeerName = m_sToPeerName;

	bStealthlisten = m_bStealthlisten;
}

//////////////////////////////////////////////////////////////////////////////
//////////////////////////////////////////////////////////////////////////////

BOOL CVaxUserData::IsRegistered()
{
	return m_bRegistered;
}

BOOL CVaxUserData::IsUserBlocked()
{
	return m_bBlocked;
}