﻿Imports System
Imports System.Collections.Generic
Imports System.Linq
Imports System.Text

Namespace VBNetSIPServerSample

    Public Class CCallStatus

        Dim sStatusBuilder As StringBuilder = New StringBuilder()

        Public Function GenOpenCallStatus(ByVal lConnectId As Long)

            sStatusBuilder.Remove(0, sStatusBuilder.Length)
            sStatusBuilder.AppendFormat("Call Opened with CallID: {0}", lConnectId)
            Return sStatusBuilder.ToString()
        End Function

        Public Function GenSuccessToCallStatus(ByVal lConnectId As Long)

            sStatusBuilder.Remove(0, sStatusBuilder.Length)
            sStatusBuilder.AppendFormat("Success To Connect with CallID: {0}", lConnectId)
            Return sStatusBuilder.ToString()
        End Function

        Public Function GenFailToCallStatus(ByVal lConnectId As Long)

            sStatusBuilder.Remove(0, sStatusBuilder.Length)
            sStatusBuilder.AppendFormat("Fail To Connect with CallID: {0}", lConnectId)
            Return sStatusBuilder.ToString()
        End Function

        Public Function GenLostCallStatus(ByVal lConnectId As Long)

            sStatusBuilder.Remove(0, sStatusBuilder.Length)
            sStatusBuilder.AppendFormat("Call Lost with CallID: {0}", lConnectId)
            Return sStatusBuilder.ToString()
        End Function

        Public Function GenCloseCallStatus(ByVal lConnectId As Long)

            sStatusBuilder.Remove(0, sStatusBuilder.Length)
            sStatusBuilder.AppendFormat("Call Closed With CallID: {0}", lConnectId)
            Return sStatusBuilder.ToString()
        End Function

        Public Function GenOffHoldStatus(ByVal lConnectId As Long)

            sStatusBuilder.Remove(0, sStatusBuilder.Length)
            sStatusBuilder.AppendFormat("Call put OffHold With CallID: {0}", lConnectId)
            Return sStatusBuilder.ToString()
        End Function

        Public Function GenOnHoldStatus(ByVal lConnectId As Long)

            sStatusBuilder.Remove(0, sStatusBuilder.Length)
            sStatusBuilder.AppendFormat("Call put OnHold With CallID: {0}", lConnectId)
            Return sStatusBuilder.ToString()
        End Function

        Public Function GenTransferBlindStatus(ByVal lConnectId As Long)

            sStatusBuilder.Remove(0, sStatusBuilder.Length)
            sStatusBuilder.AppendFormat("Call Blind Transfer With CallID: {0}", lConnectId)
            Return sStatusBuilder.ToString()
        End Function
        Public Function GenTransferConsultStatus(ByVal lConnectIdFrom As Long, ByVal lConnectIdTo As Long)

            sStatusBuilder.Remove(0, sStatusBuilder.Length)
            sStatusBuilder.AppendFormat("Call Consult Transfer From CallID: {0} To CallID: {1}", lConnectIdFrom, lConnectIdTo)
            Return sStatusBuilder.ToString()
        End Function
    End Class

    Class CUserStatus
        Dim sStatusBuilder As StringBuilder = New StringBuilder()

        Public Function GenTryingToReg(ByVal sUserName As String)

            sStatusBuilder.Remove(0, sStatusBuilder.Length)
            sStatusBuilder.AppendFormat("USER {0} Trying To Register.", sUserName)
            Return sStatusBuilder.ToString()
        End Function

        Public Function GenSuccessToReg(ByVal sUserName As String)

            sStatusBuilder.Remove(0, sStatusBuilder.Length)
            sStatusBuilder.AppendFormat("USER {0} Succes To Register.", sUserName)
            Return sStatusBuilder.ToString()
        End Function

        Public Function GenFailToReg(ByVal sUserName As String)

            sStatusBuilder.Remove(0, sStatusBuilder.Length)
            sStatusBuilder.AppendFormat("USER {0} Fail To Register.", sUserName)
            Return sStatusBuilder.ToString()
        End Function

        Public Function GenSuccessToUnReg(ByVal sUserName As String)

            sStatusBuilder.Remove(0, sStatusBuilder.Length)
            sStatusBuilder.AppendFormat("USER {0} Succes To UnRegister.", sUserName)
            Return sStatusBuilder.ToString()
        End Function
    End Class

    Class CLineStatus

        Dim sStatusBuilder As StringBuilder = New StringBuilder()

        Public Function GenTryingToRegStatus(ByVal sLineName As String)

            sStatusBuilder.Remove(0, sStatusBuilder.Length)
            sStatusBuilder.AppendFormat("LINE '{0}' Trying To Register.", sLineName)
            Return sStatusBuilder.ToString()
        End Function
        Public Function GenSuccessToRegStatus(ByVal sLineName As String)

            sStatusBuilder.Remove(0, sStatusBuilder.Length)
            sStatusBuilder.AppendFormat("LINE '{0}' Register Success.", sLineName)
            Return sStatusBuilder.ToString()
        End Function
        Public Function GenFailToRegStatus(ByVal sLineName As String)

            sStatusBuilder.Remove(0, sStatusBuilder.Length)
            sStatusBuilder.AppendFormat("LINE '{0}' Fail To Register.", sLineName)
            Return sStatusBuilder.ToString()
        End Function

        Public Function GenTryingToUnRegStatus(ByVal sLineName As String)

            sStatusBuilder.Remove(0, sStatusBuilder.Length)
            sStatusBuilder.AppendFormat("LINE '{0}' Trying To UnRegister.", sLineName)
            Return sStatusBuilder.ToString()
        End Function
        Public Function GenSuccessToUnRegStatus(ByVal sLineName As String)

            sStatusBuilder.Remove(0, sStatusBuilder.Length)
            sStatusBuilder.AppendFormat("LINE '{0}' Success To UnRegister.", sLineName)
            Return sStatusBuilder.ToString()
        End Function
        Public Function GenFailToUnRegStatus(ByVal sLineName As String)

            sStatusBuilder.Remove(0, sStatusBuilder.Length)
            sStatusBuilder.AppendFormat("LINE '{0}' Fail To UnRegister.", sLineName)
            Return sStatusBuilder.ToString()
        End Function

    End Class
End Namespace
